'use strict';

module.exports = {
  up: (queryInterface, Sequelize) => {
    return queryInterface.createTable('awards', {
      id: {
        type: Sequelize.BIGINT,
        primaryKey: true,
        autoIncrement: true
      },
      name: {
        type: Sequelize.STRING,
        allowNull: false
      },
      color: Sequelize.STRING,
      updatedAt: Sequelize.DATE,
      createdAt: Sequelize.DATE,
      icon: Sequelize.STRING,
      banner: Sequelize.STRING,
      rarity: {
        type: Sequelize.ENUM('Common', 'Uncommon', 'Rare', 'Extremely Rare', 'Impossible'),
      },
      assignedAutomatically: {
        type: Sequelize.BOOLEAN,
        defaultValue: false
      }
    }, {
      charset: 'utf8mb4'
    })
  },

  down: (queryInterface, Sequelize) => {
    return queryInterface.dropTable('awards');
  }
};