const Errors = require('../lib/errors')

module.exports = (sequelize, DataTypes) => {
    let Award = sequelize.define('Award', {
        name: {
            type: DataTypes.STRING,
            allowNull: false
        },
        color: DataTypes.STRING,
        updatedAt: DataTypes.DATE,
        createdAt: DataTypes.DATE,
        icon: DataTypes.STRING,
        banner: DataTypes.STRING,
        description: DataTypes.TEXT,
        rarity: {
            type: DataTypes.ENUM('Common', 'Uncommon', 'Rare', 'Extremely Rare', 'Impossible'),
            defaultValue: 'Common'
        },
        assignedAutomatically: {
            type: DataTypes.BOOLEAN,
            defaultValue: false
        }
    })
    return Award
}