const Errors = require('../lib/errors')

module.exports = (sequelize, DataTypes) => {
    let Feedback = sequelize.define('Feedback', {
        id: {
            type: DataTypes.BIGINT,
            primaryKey: true,
            autoIncrement: true
        },
        route: {
            type: DataTypes.TEXT,
            defaultValue: '/',
            allowNull: false
        },
        email: {
            type: DataTypes.TEXT,
            validate: {
                isEmail: true
            }
        },
        stars: {
            type: DataTypes.INTEGER,
            validate: {
                min: 1,
                max: 5
            }
        },
        text: {
            type: DataTypes.TEXT,
            validate: {
                len: [5, 512]
            }
        },
        createdAt: DataTypes.DATE,
        updatedAt: DataTypes.DATE
    }, {
        freezeTableName: true
    })
    return Feedback
}