let express = require('express')
let router = express.Router()
const auth = require('../lib/auth')

let { User, Post, Item, Inventory, Team, Thread } = require('../models')

router.get('/', async(req, res, next) => {
    try {
        let users = await User.count();
        let posts = await Post.count();
        let threads = await Thread.count();
        let items = await Item.count();
        let inventory = await Inventory.count();
        let teams = await Team.count();
        res.json({ users, posts, items, inventory, teams, threads });
    } catch (e) { next(e) }
})

module.exports = router
