let express = require('express')
let router = express.Router()
const auth = require('../lib/authUserInfo')
const auth2 = require('../lib/auth')
const Errors = require('../lib/errors')
let { User, Ban } = require('../models')

router.get('/', auth, auth, async(req, res, next) => {
    try {
        let queryObj = {
            attributes: {exclude: ['hash', 'currency2', 'emailToken', 'passwordResetToken', 'deleteCode', 'deleteEnabled', 'jwtOffset']},
            where: {username: req.userData.username}
        }
         let user = await User.findOne(queryObj)
         if(!user) {
             res.status(200)
             res.json({
                 errors: ["Please login to use this endpoint, idk what you expected"]
             })
             res.end()
         } else {
             res.status(200)
             res.json(user)
         }
    } catch (err) { next(err) }
})

router.get('/banStatus', auth, async(req, res, next) => {
    try {
        let queryObj = {
            where: {UserId: req.userData.id}
        }
        let user = await Ban.findOne(queryObj)
        if(!user) {
            res.status(200)
            res.json({success: true, user: { ReadOnlyMode: false, ipBanned: false, DisableLogin: false, message: "Not banned" }, banned: false})
            res.end()
        } else {
            res.status(200)
            res.json({success: true, user, banned: true})
        }
    } catch (err) { next(err) }
})

router.get('/auth', auth2, async(req, res, next) => {
    try {
        let queryObj = {
            attributes: {exclude: ['hash', 'currency2', 'emailToken', 'passwordResetToken', 'deleteCode', 'deleteEnabled', 'jwtOffset']},
            where: {username: req.userData.username}
        }
        let user = await User.findOne(queryObj)
        if(!user) {
            res.status(500)
            res.json({
                errors: ["ERROR"]
            })
            res.end()
        } else {
            res.status(200)
            res.json(user)
        }
    } catch (err) { next(err) }
})

module.exports = router
